## ros-foxy-udp-driver 1.0.0

=== CMakeLists.txt ===
# Copyright 2018 Apex.AI, Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Co-developed by Tier IV, Inc. and Apex.AI, Inc.
# Maintained by LeoDrive, 2021

cmake_minimum_required(VERSION 3.5)
project(udp_driver)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

## dependencies
find_package(ament_cmake_auto REQUIRED)
ament_auto_find_build_dependencies()

find_package(asio_cmake_module REQUIRED)
find_package(ASIO REQUIRED)

ament_auto_add_library(${PROJECT_NAME} SHARED
  src/udp_socket.cpp
  src/udp_driver.cpp
)
ament_target_dependencies(${PROJECT_NAME} "ASIO")

ament_auto_add_library(${PROJECT_NAME}_nodes SHARED
  src/udp_receiver_node.cpp
  src/udp_sender_node.cpp
)
ament_target_dependencies(${PROJECT_NAME}_nodes "ASIO")
target_link_libraries(${PROJECT_NAME}_nodes ${PROJECT_NAME})

rclcpp_components_register_node(${PROJECT_NAME}_nodes
  PLUGIN "drivers::udp_driver::UdpReceiverNode"
  EXECUTABLE udp_receiver_node_exe
)

rclcpp_components_register_node(${PROJECT_NAME}_nodes
  PLUGIN "drivers::udp_driver::UdpSenderNode"
  EXECUTABLE udp_sender_node_exe
)

ament_auto_add_executable(udp_bridge_node_exe
  src/udp_bridge_node.cpp
)

target_link_libraries(udp_bridge_node_exe ${PROJECT_NAME} ${PROJECT_NAME}_nodes)
ament_target_dependencies(udp_bridge_node_exe ASIO)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  set(TEST_FILES
    test_udp_socket.cpp
    test_udp_data.cpp
    test_udp_driver.cpp
    test_udp_driver_nodes.cpp)

  foreach(file ${TEST_FILES})
    get_filename_component(name "${file}" NAME_WE)
    set(TEST_UDP_DRIVER_EXE ${name})

    ament_add_gtest(${TEST_UDP_DRIVER_EXE}
      test/${name}.cpp)
    ament_target_dependencies(${TEST_UDP_DRIVER_EXE}
      rclcpp
      std_msgs
      udp_msgs
      lifecycle_msgs
      ASIO)

    target_include_directories(${TEST_UDP_DRIVER_EXE} PRIVATE include)
    target_link_libraries(${TEST_UDP_DRIVER_EXE} ${PROJECT_NAME} ${PROJECT_NAME}_nodes)
  endforeach()
endif()

ament_auto_package(
  CONFIG_EXTRAS_POST "udp_driver-extras.cmake"
)

=== debian/changelog ===
ros-foxy-udp-driver (1.0.0-1focal) focal; urgency=high

  * update READMEs for each package (#54 <https://github.com/ros-drivers/transport_drivers/issues/54>)
    * update READMEs for each package
    * add more to readme, renamed config to params
  * use vectors not mutbuffers (#50 <https://github.com/ros-drivers/transport_drivers/issues/50>)
  * Port udp_driver Changes to serial_driver (#47 <https://github.com/ros-drivers/transport_drivers/issues/47>)
    * Adding SerialPort and framework for SerialDriver.
    * Adding SerialDriver
    * Adding SerialBridgeNode
    * Remove serial_driver_node and tests
    * Create new tests for serial_port and serial_driver
    * Changing signature of from_msg for example_interfaces
    * [serial_driver] Adding missing function definition
    * [serial_driver] Adding example params and launch files
    * Trying to apease flake8
    * Fixing allocation snafu
    * [serial_driver] Replacing MutBuffer with std::vector<uint8_t>
    * [serial_driver] Fix typo
    * [serial_driver] Make launch file more reliable
    * [serial_driver] Fix error message
    * [serial_driver] Fix typo
    * [serial_driver] Shorten node name
  * Generic udp nodes (#40 <https://github.com/ros-drivers/transport_drivers/issues/40>)
    * use udp_msgs for receiver and sender nodes
    * use vector of uint8_ts instead of mutable buffer
    * all tests passing
  * Rename MutSocketBuffer to MutBuffer (#46 <https://github.com/ros-drivers/transport_drivers/issues/46>)
  * Removing duplicate file
  * Export ASIO definitions (#44 <https://github.com/ros-drivers/transport_drivers/issues/44>)
  * Enforce C++14. Do not duplicate compiler flags (#45 <https://github.com/ros-drivers/transport_drivers/issues/45>)
  * Deduplicate ASIO CMake module (#43 <https://github.com/ros-drivers/transport_drivers/issues/43>)
    * Added ASIO CMake module
    * Use asio_cmake_module
  * Use RCLCPP logging macros (#42 <https://github.com/ros-drivers/transport_drivers/issues/42>)
  * Fix copyright years (#41 <https://github.com/ros-drivers/transport_drivers/issues/41>)
  * Fix IoContext thread management
  * Pass IoContext through driver instead of storing reference
  * Replace ptrs to IoContext with refs
  * Removed Boost (#39 <https://github.com/ros-drivers/transport_drivers/issues/39>)
    * Removed Boost
    * Do not depend on Boost at all
    * Added cmath header
    * Fix linting warning
    * Added ASIO_STANDALONE to more units
    * Call stop on io_service
    * Fix dependency
    * Export asio as a downstream dependency
    * Remove more boost references
    * Force non-Boost version of ASIO
    * Force non-Boost version of ASIO
    * Ignore result to avoid compiler warning
  * Add warnings for invalid or missing parameters in udp_driver nodes
  * Create Full UDP Nodes (#38 <https://github.com/ros-drivers/transport_drivers/issues/38>)
    * Reorganize namespaces
    * Apply reviewer feedback
    * Create UdpReceiverNode as LifecycleNode
    * Create UdpSenderNode as Lifecycle Node
    * Adding bridge node
    * Add comment to bridge node about purpose
  * Reorg namespaces (#37 <https://github.com/ros-drivers/transport_drivers/issues/37>)
    * Move UDP driver node to correct location
    * Reorganize namespaces
    * Remove unused include_directories
    * Apply reviewer feedback
  * move io_context to shared lib (#36 <https://github.com/ros-drivers/transport_drivers/issues/36>)
  * Re-apply ament_cmake_auto to udp_driver
  * remove autoware namespace (#35 <https://github.com/ros-drivers/transport_drivers/issues/35>)
    * remove autoware namespace
    * move msgs namespace to utils
  * Implement UdpSocket for both Syn. & Async modes (Send & Receive functionality) (#31 <https://github.com/ros-drivers/transport_drivers/issues/31>)
    * Refactor & add UdpReceiver class
    * Add UdpSender class
    * Update node class to refactored driver
    * Update CMake
    * Update tests
    * Resolve a conflict on test/test_udp_driver.cpp
    * Update Readme
    * Rename header file to cpp format
    * Rename header file to cpp format
    * Delete old files
    * Update Udp Driver Node
    * Add message converters
    * Add IoContext class
    * Add UdpDriver class
    * Add UdpSocket class
    * Add IoContext test case
    * Add Udp data transmission test cases
    * Add Udp receive test case
    * Add Udp Sender test case
    * Add UdpDriver test cases
    * Update CMakeLists file
    * Add converters header & source files
    * Add IoContext header & source files
    * Add UdpSocket header & source files
    * Add UdpDriver header & source files
    * Add visibility header file
    * Add UdpDriverNode to examples directory
    * Add main google test program
    * Add IoContext test
    * Add UdpSocket test
    * Add UdpDriver test
    * Add UDP communication tests
    * Add UdpDriverNode test
    * Add changelog file
    * Add CMakeLists file
    * Add package.xml file
    * Delete old udp_driver package
    * Add design document
    * Add std_msgs/Int* variants converters
    * Update converters to ROS2 message in function names
    * Refactor converters to their ROS2 namespaces in converters directory
    * Add common converters header
    * Update licenses
    * Reformat code
    * Remove unnecessary print
    * Update google test header includes to library convention
    * Implement unsigned integer and floating point message variants converters
    * Fix comment in converters
    * Update test and example
    * Update changelog - Bump major version to 0.1.0
    * Update readme
    * Revert back changelog file
    * Update readme
    * Move udp_driver to separate package
    * Revert package name change
    * Apply linter fixes
    Co-authored-by: Joshua Whitley <mailto:josh.whitley@autoware.org>
  * Make Nodes Component-Compatible (#22 <https://github.com/ros-drivers/transport_drivers/issues/22>)
    * Making constructors for SerialDriverNode component-compatible.


=== debian/control ===
Source: ros-foxy-udp-driver
Section: misc
Priority: optional
Maintainer: Joshua Whitley <whitleysoftwareservices@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libasio-dev, ros-foxy-ament-cmake-auto, ros-foxy-ament-cmake-gtest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-asio-cmake-module, ros-foxy-io-context, ros-foxy-lifecycle-msgs, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rclcpp-lifecycle, ros-foxy-std-msgs, ros-foxy-udp-msgs, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-udp-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libasio-dev, ros-foxy-io-context, ros-foxy-lifecycle-msgs, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rclcpp-lifecycle, ros-foxy-std-msgs, ros-foxy-udp-msgs, ros-foxy-ros-workspace
Description: A library to write Synchronous and Asynchronous networking applications, ROS and ROS2 nodes

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-udp-driver//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
